unit BaseRptFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SctVar, SctCtrl, ExtCtrls, SctRep;

type
  TBaseRptForm = class(TForm)
    BaseRpt: TSctReport;
    ReportPage: TSctGrouppage;
    ReportHeaderBand: TSctBand;
    ReportHeaderBandlevel: TSctLevel;
    BaseHead: TSctBand;
    PageHeaderBandlevel: TSctLevel;
    DetailBand: TSctBand;
    DetailBandlevel: TSctLevel;
    PageFooterBand: TSctBand;
    PageFooterBandlevel: TSctLevel;
    ReportFooterBand: TSctBand;
    ReportFooterBandlevel: TSctLevel;
    SctImageLabel1: TSctImageLabel;
    Sctvarlabel1: TSctvarlabel;
    Sctvarlabel2: TSctvarlabel;
    Sctvarlabel3: TSctvarlabel;
    svarDateTime: TSctDateTimeVar;
    svarPage: TSctPageVar;
    Sctvarlabel4: TSctvarlabel;
    MyRptNameLabel: TSctvarlabel;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure BaseRun(Rep: TSctReport);
  end;

var
  BaseRptForm: TBaseRptForm;

implementation
uses clipbrd, acertfc;

{$R *.DFM}
procedure TBaseRptForm.BaseRun(Rep: TSctReport);
var
  Src, Dest: TSctBand;
  i, OldCount: integer;
  vpg: TSctPageVar;
  vdt: TSctDateTimeVar;
begin
  Src := BaseRpt.Page.PageHead;
  Dest := Rep.Page.PageHead;

  // Copy the page header's height.  Note that you may also
  // wish to copy other properties like the BorderType, Color,
  // Shade and Font 
  Dest.Height := Src.Height;

  // Remember if there were any labels already on the header
  if Dest.Labels = nil then OldCount := 0
                       else oldCount := Dest.Labels.Count;

  // Find the SYS vars
  i := 0;
  vpg := nil;
  vdt := nil;
  while i < Rep.Page.VarList.Count do
  begin
    if TSctVar(Rep.Page.VarList[i]).id = vidPageVar then
              vpg := TSctPageVar(Rep.Page.VarList[i]);
    if TSctVar(Rep.Page.VarList[i]).id = vidDateTimeVar then
              vdt := TSctDateTimeVar(Rep.Page.VarList[i]);
    Inc(i);
  end;
  // Copy the labels
  i := 0;
  while i < Src.Labels.Count do
  begin
    ClipBoard.Clear;
    ClipBoard.SetComponent( Src.Labels[i]);
    ClipBoard.GetComponent( Dest.Owner, Dest);
    Inc(i);
  end;
  // Modify the copied labels
  i := 0;
  while i < Dest.Labels.Count do
  begin
    if TSctLabel(Dest.Labels[i]) is TSctVarLabel then
    begin

      // Perhaps set a label to be automatically filled in with the
      // report's Description property
      if TSctVarLabel(Dest.Labels[i]).Name = 'MyRptNameLabel' then
         TSctVarLabel(Dest.Labels[i]).Caption := Rep.Page.Description;

      // Replace the SvarPage and SvarDateTime variables
      if TSctVarLabel(Dest.Labels[i]).Variable <> nil then
      begin
        if TSctVarLabel(Dest.Labels[i]).Variable.id = vidPageVar then
          TSctVarLabel(Dest.Labels[i]).Variable := vpg;
        if TSctVarLabel(Dest.Labels[i]).Variable.id = vidDateTimeVar then
          TSctVarLabel(Dest.Labels[i]).Variable := vdt;
      end;
    end;
    Inc(i);
  end;
  Rep.Run;
  // Delete any labels that we added to the report
  // Skip past any that were already there when we started
  i := Dest.Labels.Count-1;
  while i >= OldCount do
  begin
    TSctLabel(Dest.Labels[i]).Free;
    Dec(i);
  end;
end;

initialization

  RegisterClasses([ TSctVarLabel,
                    TSctImageLabel,
                    TSctLine,
                    TSctBarCodeLabel,
                    TSctCheckLabel,
                    TSctCustomLabel,
                    TSctShape,
                    TSctTotalVarLabel,
                    TSctVerticalDivider,
                    TSctRichTextLabel
                  ]);
end.
